@echo off
rem makeiso.bat - v2.59 BBL/KJD 2003-09-12
REM We expect to be in same directory as makeiso.bat
REM You may also start it directly (double click) from Explorer on Windows NT,
REM and also in Win9x if FreeCOM 0.82patchlevel2 or newer is present

rem support command line help
if [%1]==[/?] goto usage
if [%1]==[/help] goto usage

rem so we can determine where files are we must start in same dir as this file
if not exist makeiso.bat goto error

rem check if restarted using FreeCom
if [%1]==[/skipchecks] goto begin

rem verify we can find path, either implied by supported command.com else explicit
*** ??? if not [%1]==[] goto console
if [%OS%]==[Windows_NT] goto begin
if not exist command.com goto usage
if [%_CWD%]==[] command.com /c %0 /skipchecks
goto usage

*** ??? :console
*** ??? if not exist ..\..\..\%1\isolinux\buildcd\makeiso.bat goto error2
*** ??? rem Correct directory has just been verified!
*** ??? set BASEDIR=%1
*** ??? goto begin


:begin

:makeiso
*** !!! rem Switch to the root folder of FreeDOS distro!
CD ..
CD ..
REM isolinux\boot.cat must not be read-only so we can modify it
isolinux\utils\attrib -r isolinux\*.*

rem Note this line here as we must be in BASEDIR for it to work correctly.
rem If freecom used on NT, override FreeCOM's %_CWD% as it cannot handle
rem Long FileNames, and NT cannot handle abcdef~1 shortened filenames (9X can!)
rem if BaseDir variable filled, means %1 is contents, so console, so skip %CD% or %_CWD%
if not [%BASEDIR%]==[] goto setvars
rem %1 hasn't been entered, so try to determine current directory
if not [%_CWD%]==[] set BASEDIR=%_CWD%
if [%OS%]==[Windows_NT] set BASEDIR=%CD%
goto setvars

:setvars
rem Mkisofs 2.01a15-DJGPP internal variable:
SET MKISOFSRC=

rem public build
rem Ramdisk support if global presence of %RAMDISK%
rem ISONAME means output filename MUST be present in the resourcefile (*.rc)
CD ..
if not "%MKISOFSRC%"=="" GOTO find_exe
set MKISOFSRC=%BASEDIR%\isolinux\buildcd\mkisofd.rc
set isofile=fdbootcd.iso
if not "%ramdisk%"=="" set isofile=%ramdisk%\%isofile%
goto warndel


:warndel
if "%isofile%"=="" goto find_exe
if not exist %isofile% goto find_exe
echo WARNING!!! %isofile% already exists!
echo This file will be replaced.
echo Press Ctrl-C (or Ctrl-Break) to abort.
pause
if exist %isofile% del %isofile%
goto find_exe

:find_exe
rem drop one more directory down, so just below root of CD contents
if "%OS%"=="Windows_NT" title Compiling CD ( %basedir% - %isofile% ) . . . 
if not "%isofile%"=="" set isofile=-o %isofile%
set ISOparams=-follow-links -cache-inodes %isofile%
set ISOparams=%isofile%
rem Let's do a search for MKISOFS here..
set mkisoexe=none
if exist %basedir%\isolinux\buildcd\mkisofs.exe set mkisoexe=%basedir%\isolinux\buildcd\mkisofs.exe
for %%d in (%path%) do if exist %%d\mkisofs.exe set mkisoexe=%%d\mkisofs.exe
for %%d in (%path%) do if exist %%dmkisofs.exe set mkisoexe=%%dmkisofs.exe
goto CreateCD

:CreateCD
REM actually create the ISO image, either from found mkisofs or from mkisofs if in path (smaller cd)
*** !!! so dfl is unused:
*** !!! rem if not [%mkisoexe%]==[none] dfl.exe %BASEDIR% link -d
if not [%mkisoexe%]==[none] %mkisoexe% %ISOparams% %BASEDIR%
if [%mkisoexe%]==[none] echo Warning: MKISOFS.EXE executable not found in directory BUILDCD or path.
if [%mkisoexe%]==[none] pause
rem sample command line if you are building without buildcd\ present
rem mkisofs -N -r -J -v -volid FDOSRIPCORD -p "Unknown" -P "FreeDOS - www.fdos.org" -A "FreeDOS Ripcord CD-ROM ISO" -b isolinux/isolinux.bin -hide-rr-moved -no-emul-boot -boot-load-size 4 -boot-info-table -hide boot.catalog -hide-joliet boot.catalog -o fdbootcd.iso current-iso

rem Time to switch back to original directory
CD %BASEDIR%
CD ISOLINUX
CD BUILDCD

rem remove our env vars
set BASEDIR=
set CD_VERBOSE=
set CD_VOLID=
set CD_PREPARER=
set CD_PUBLISHER=
set CD_APPID=

goto end


:usage
echo.
echo USAGE: %0 source
echo.
echo where source is the directory name you copied the FreeDOS CD contents to.
echo (source may be ommitted on Windows NT or if recent enough FreeCom is used)
echo e.g.    %0 current-iso
echo.
echo you must start this batch file from the same directory as this batch file
goto end

:error
echo You must run makeiso.bat from the same directory it is in.
echo (This allows it to use relative paths.)
echo To build your own customized ISO image, copy the entire
echo contents of the CD to a directory on your hard drive
echo (complete path should not exceed 80 characters), and then
echo make your modifications (removing read-only flag as needed).
echo When you are happy and ready to create a new ISO, change
echo to the directory with this file (e.g. CD \TEMP\FDCD\isolinux\BUILDCD\ )
echo and then run MAKEISO.BAT (this file).
echo NOTES: 
echo - you can of course use other tools, but be aware
echo isolinux requires no emulation mode and I have only tested
echo via mkisofs [Windows port]
echo - ..\..\..\fdbootcd.iso will be overwritten if exists, this
echo is the new ISO image.
goto end

:error2
echo.
echo ERROR: the source path you entered ( parameter: %1 ) 
echo        does not seem correct.
echo.
echo We expect file makeiso.bat to be in the expected place:
echo ..\..\..\%1\isolinux\buildcd\makeiso.bat
echo Unfortunately it's not . . .
echo.
echo Please try again.
echo.
goto end

:end
REM Ensure user has a chance to read any messages when started via Explorer
if not [%1]==[] goto totalend
if not [%OS%]==[Windows_NT] pause
if not [%OS%]==[Windows_NT] goto totalend
title Compiling CD - DONE!
set /p pausevar=Press ENTER key to continue . . .
for %%x in ( [] [ ] [  ] ) do if [%pausevar%]==%%x goto totalend
if not "%pausevar%"=="" goto nameISO 
goto totalend
:nameISO
rem Intended replacement! delete/rename faster than overwriting through copying.
CD ..
CD ..
CD ..

if exist %pausevar% del %pausevar%
if exist fdbootcd.iso ren fdbootcd.iso %pausevar%
goto totalend

:totalend
rem This batchfile by Bernd Blaauw and Jeremy Davis (2002-2003)
rem Resulting file is ..\..\..\FDBOOTCD.ISO as you can see from the mkisofs line. 
rem Burn it with CDrecord found in WIN32 directory (cdrecord -scanbus is useful)
rem but DO create the ISO file by running this batchfile (mkisofs use required by isolinux)!!!
rem File may be burned using NERO by selecting ("burn imagefile"). 
rem this is required for overburning, since cdrecord version I use does not support it.
rem Next CDrecord release should be SOON(tm)
